# Example taken from
# https://gitlab.com/yaook/operator/-/raw/devel/docs/examples/neutron-ovn.yaml
# adopted for EVT by porting over the OVS version of this config from Titan
apiVersion: yaook.cloud/v1
kind: NeutronDeployment
metadata:
  name: neutron-ovn
  namespace: yaook
spec:
  api:
    ingress:
      fqdn: "{{ fqdn_neutron }}"
      port: 443
      # externalCertificateSecretRef:
      #  name: neutron-api-external-certificate
    replicas: 3
  database:
    backup:
      schedule: "0 * * * *"
    proxy:
      replicas: 3
    replicas: 3
    storageClassName: csi-driver-lvm-linear
    storageSize: 20Gi
    mysqlConfig:
      mysqld:
        max_allowed_packet: 256M
        max_connections: 4096
        max_heap_table_size: 64M
        expire_logs_days: 2
  issuerRef:
    name: ca-issuer
  keystoneRef:
    name: keystone
  messageQueue:
    replicas: 3
    storageClassName: csi-driver-lvm-linear
    storageSize: 16Gi
  memcached: {}
  neutronConfig:
    DEFAULT:
      debug: false
      dhcp_agents_per_network: 2  # setting copied from Titan
      global_physnet_mtu: 1558
      # https://docs.openstack.org/neutron/zed/configuration/neutron.html#DEFAULT.api_workers
      api_workers: 8
      rpc_workers: 4
    ml2:
      path_mtu: 1558
    oslo_messaging_rabbit:
      # https://docs.openstack.org/neutron/zed/configuration/neutron.html#oslo-messaging-rabbit
      # rabbit_quorum_queue is true by default in Yaook
      heartbeat_in_pthread: false
      heartbeat_rate: 3  # https://review.opendev.org/c/openstack/oslo.messaging/+/875615
    oslo_messaging_notifications:
      driver:
      - messagingv2
  neutronML2Config:
    ovn:
      dns_servers: "{{ neutron_dns_server }}"
    ml2_type_flat:
      flat_networks:
      - provider1000
  novaRef:
    name: nova
  policy:
    "context_is_admin": "role:admin"
  region:
    name: {{ region_name }}
  setup:
    ovn:
      northboundOVSDB:
        replicas: 3
        backup:
          schedule: 0 12 * * *
      northd: {}
      southboundOVSDB:
        # recommended to increase inactivityProbe at scale (default 5s)
        inactivityProbeMs: 60000
        ovnRelay:  # add this section to deploy ovn-relays
          replicas: 3
        replicas: 3
        backup:
          schedule: 0 12 * * *
      controller:
        configTemplates:
        - nodeSelectors:
          - matchLabels: {}  # all nodes
        - nodeSelectors:
          - matchLabels:
              "network.yaook.cloud/neutron-ovn-agent": "true"
          bridgeConfig:
            - bridgeName: br-prv-1000
              uplinkDevice: bond0.1000
              openstackPhysicalNetwork: "provider1000"
  targetRelease: {{ neutron_targetRelease }}
